/*
  Name : alert.hpp
  Copyright : KPAMEGAN & ROUSSET
  Authors : KPAMEGAN Karel, ROUSSET Baptiste
  Description: file which contents function to generate alerts on a LCD screen
*/

#ifndef _alert_h_
#define _alert_h_

#include "base.hpp"
#include "effect.hpp"
#include <list>
#include <iostream>

using namespace std;

class Alert : public Screen{
private:
  list<char *> listAlert;         //list of alerts
  Effect *effect;                 //an effect screen
  char *title;                    //the title of the alert screen

public:
  Alert();                        //this is a constructor
  Alert(char *newTitle);	  //this is a constructor
  ~Alert();                       //this is the destructor
  void add_Alert(char *alert);    //add an alert into the list
  void clean_Alert(void);         //clear the list of all the alerts
  void set_title(char *newTitle); //set the title of the screen
  int show_Alert(void);           //display the alerts
};

#endif

