/*
  Name : pump.hpp
  Copyright : MARTY & FOK
  Authors : MARTY Sbastien & FOK Pierre
  Description: file which contents functions to use a pump
*/

#ifndef _PUMP_HPP_
#define _PUMP_HPP_

#include "param.h"
#include "util.h"
#include "other.hpp"
#include "objet.hpp"

class Pump:public Objet
{
private:
  short stop;
  bool stop_p;// used for stopping pump

  time_t rawtime;
  time_t t_timer;


  void forceState(short ,connexion &,K8055 &,config &);//force the state
  void bouttonApp ();//button for stopping the pump
  void stop10 (connexion &,K8055 &,config &);//stop the pump for 10 min 
  void changeState (short,connexion &,K8055 &,config &);//change the state

public:
  Pump(){}
  void init();
  
  short getStop ();
  bool getStop_p ();

  void setStop(short);
  void setStop_p (bool);
  
  
  void changing(short st,connexion &,K8055 &,config &);//check the state of the pump


};

#endif

