/*
  Name : routine.cpp
  Copyright : KPAMEGAN & ROUSSET
  Authors : KPAMEGAN Karel, ROUSSET Baptiste
  Description: file which contents function to set configuration of the aquarium on the screen
*/

#include "routine.hpp"

extern pthread_mutex_t mut;             //variable of exclusion which comes from main.cpp
extern shareData dataVal;               //variable which contents configuration of the aquarium which comes from main.cpp
extern InitTimes confTimes;             //initialize times between 2 screens which comes from main.cpp
Alert alert;                            //the alerts screen
Alert logs("LOGS");                     //the logs screen 

/*
  Name : lcdRoutine
  Finality : display on the screen the aquarium configuration
  Decription : we take configuration of the aquarium,
               we take alerts and logs,
	       we display the configuration of the aquarium,
               if there are alerts or logs we display them
*/
void *lcdRoutine(void *)
{
time_t t;
int st,sh;
  Configuration screen1(1);      //this screen contents the temperature, skimmer, peristatic, and temp configuration
  Configuration screen2(2);      //this screen contents blue, osmolation, rah, and pump configuration
  Effect transition(&screen1);
  while(1)
    {
	time (&t);
	string s=ctime(&t); 
	string s2=s.substr(s.find(":",0)+1,2);
	st=atoi(s2.c_str()); // minute
	s2=s.substr(s.find(":",0)-2,2); 
	sh=atoi(s2.c_str()); //hour
	
	if (st==0 && sh==0)
		{
		 pthread_mutex_lock(&mut);   
		alert.clean_Alert(); //delete the list of alerts
		if(confTimes.get_bool_log())
		logs.clean_Alert(); //delete list of logs
		    pthread_mutex_unlock(&mut);  
		

		}

      pthread_mutex_lock(&mut);                  //we lock the access to dataVal and we take the configuration of the aquarium

      screen1.set_param1_value(dataVal.temperature);
      screen1.set_param2_value(dataVal.ecumeur);
      screen1.set_param3_value(dataVal.pompes);
      screen1.set_param4_value(dataVal.chauffage);
      screen2.set_param1_value(dataVal.reserve);
      screen2.set_param2_value(dataVal.osmolation);
      screen2.set_param3_value(dataVal.rah);
      screen2.set_param4_value(dataVal.gdespompes);
      while(!dataVal.lalert.empty())              //we take all the alert of the list of dataVal
	{
	  alert.add_Alert((dataVal.lalert).front());
	  (dataVal.lalert).pop_front();
	}
      while(!dataVal.llogs.empty())               //we take all the logs of the list of dataVal
	{
	  logs.add_Alert((dataVal.llogs).front());
	  (dataVal.llogs).pop_front();
	}
      pthread_mutex_unlock(&mut);                 //we unlock dataVal

	screen1.set_separators();
	screen2.set_separators();
      screen1.show();                             //we display the first configuration screen
      sleep(confTimes.get_timeInterScreen());     //we wait the time contents in confTimes.get_timeInterScreen()
      transition.pass_screen_up(1);
	
      screen2.show();                             //we display the second configuration screen
      sleep(confTimes.get_timeInterScreen());     //we wait the time contents in confTimes.get_timeInterScreen()
      alert.show_Alert();                      //we display alerts if there are
      if (confTimes.get_bool_log())               //we display logs if it is wanted in confTimes.get_bool_log() and if there are
        logs.show_Alert();
	screen1.delete_screen();
		screen2.delete_screen();
    }
}
