/*
  Name : skimmer.hpp
  Copyright : MARTY & FOK
  Authors : MARTY Sbastien & FOK Pierre
  Description: file which contents functions to use a skimmer
*/

#ifndef _SKIMMER_HPP_
#define _SKIMMER_HPP_

#include "param.h"
#include "util.h"
#include "other.hpp"
#include "objet.hpp"

class Skimmer:public Objet
{
private:
  short state_high;// state of the level water
  short stop;// state of the physical button (input 2) for stopping pump skimmer
  short stop_sk;// used for stopping pump skimmer 2min
  bool forced;// used to check if skimmer has been forced to run it if necessary
  time_t t_sk;
  time_t rawtime;

  void forceState(short,connexion &,K8055 &,config &);//force the state of the skimmer
  void start (connexion &,K8055 &,config &);//start the skimmer
  void deborde(connexion &,K8055 &,config &);//if the water level is too high
  void debordePlus(connexion &,K8055 &,config &);//if the water backs to a normal level
  void stoppe(connexion &,K8055 &,config &);//if the physiqual button is pressed, stop the skimmer
  void stoppePlus(connexion &,K8055 &,config &);//enable the skimmer after X min stopped
  
  
public:
  Skimmer(){}
  void init();
  
 
  short getState_high();
  short getStop ();
  bool getStop_sk ();
  bool getForced();

  void setState_high(short);
  void setStop(short);
  void setStop_sk (bool);
  void setForced (bool);
 
  void changeState (short,connexion &,K8055 &,config &);//change the state
  void changing (short,short,connexion&,K8055&,config&);//check the state of the skimmer
};

#endif
