<?php
/*
 * This work is hereby released into the Public Domain.
 * To view a copy of the public domain dedication,
 * visit http://creativecommons.org/licenses/publicdomain/ or send a letter to
 * Creative Commons, 559 Nathan Abbott Way, Stanford, California 94305, USA.
 *
 */

require_once "../LinePlot.class.php";


$graph = new Graph(800, 300);
$graph->setAntiAliasing(TRUE);

$green = new Color(125, 250, 0);
$red = new Color(200, 0, 0);



$group = new PlotGroup;

// Set a background gradient
$group->setBackgroundGradient(
	new LinearGradient(
		new Color(210, 210, 210),
		new Color(255, 255, 255),
		0
	)
);

$group->setPadding(40,40);
$group->axis->left->title->set("Température");

$x = array(
	31, 25, 25, 23.5, 20, 32, 31, 30, 29, 28, 28.1, 28, 29.2, 24.3, 30.1, 21, 24, 23.5, 21, 25.3, 25.6, 26.6, 25, 24.3 ,31);

$plot = new LinePlot($x);




// Change line color
$plot->setColor(new Color(0, 0, 150, 20));


// Change mark type
$plot->mark->setType(MARK_CIRCLE);
$plot->mark->border->show();
//$plot->xAxis->title->set("Heures");
//$plot->xAxis->title->setFont(new TuffyBold(10));
//$plot->xAxis->setTitleAlignment(LABEL_RIGHT);
//$plot->yAxis->title->set("Température");
//$plot->yAxis->title->setFont(new TuffyBold(10));
//$plot->yAxis->title->move(-4, 0);
//$plot->yAxis->setTitleAlignment(LABEL_TOP);
$plot->yAxis->setLabelPrecision(1);
//$plot->setXAxisZero(FALSE);


$plot->label->set($x);
$plot->label->move(0, -23);
$plot->label->setBackgroundGradient(
	new LinearGradient(
		new Color(250, 250, 250, 10),
		new Color(255, 200, 200, 30),
		0
	)
);
$plot->label->border->setColor(new Color(20, 20, 20, 20));
$plot->label->setPadding(3, 1, 1, 0);
$plot->setYMin(18);
$plot->setYMax(35);


$group->add($plot);


$x = array(
	20, 22, 24, 21.5, 28, 37, 34, 31, 22, 28, 28.1, 28, 29.2, 24.3, 30.1, 21, 24, 23.5, 21, 25.3, 25.6, 26.6, 25, 24.3 ,31);

$plot = new LinePlot($x);
// Change line color
$plot->setColor($red);
$plot->setYMin(18);
$plot->setYMax(35);
$plot->setStyle(3);
$group->add($plot);
$plot->setXAxisZero(FALSE);

$x = array(
	27, 18, 25, 20.5, 27, 32, 31, 36, 20, 28, 28.1, 28, 29.2, 24.3, 30.1, 21, 24, 23.5, 21, 25.3, 25.6, 26.6, 25, 24.3 ,31);

$plot = new LinePlot($x);
// Change line color
$plot->setColor($green);
$plot->setYMin(18);
$plot->setYMax(35);
$plot->setStyle(3);
$plot->setXAxisZero(FALSE);

$group->add($plot);


$graph->add($group);

$graph->draw();
?>
